from .. import schema_to_class as s2c
import json

cases = -1
durations = []
daily_import_pressures = []
nodes = []

def app( timestep ):
    event = s2c.get_default_campaign_event()
    coordinator = s2c.get_class_with_defaults( "StandardEventCoordinator" )
    if coordinator is None:
        print( "s2c.get_class_with_defaults returned None. Maybe no schema.json was provided." )
        return ""
    coordinator.Max_Cases_Per_Node = cases
    event.Event_Coordinator_Config = coordinator
    intervention = s2c.get_class_with_defaults( "ImportPressure" )
    coordinator.Intervention_Config = intervention
    event.Start_Day = float(timestep+1)

    if len( durations ) == 0:
        Ex = ValueError()
        Ex.strerror = "durations not set."
        raise Ex
    if len( daily_import_pressures  ) == 0:
        Ex = ValueError()
        Ex.strerror = "daily_import_pressures not set."
        raise Ex
    if len( daily_import_pressures ) != len( durations ):
        Ex = ValueError()
        Ex.strerror = "durations and daily_import_pressures neeed to have same number of entries." 
        raise Ex
    intervention.Durations = durations
    intervention.Daily_Import_Pressures = daily_import_pressures

    if len(nodes) > 0:
        nodelist = s2c.get_class_with_defaults( "NodeSetNodeList" )
        nodelist.Node_List = nodes
        event.Nodeset_Config = nodelist
        nodelist.finalize()

    coordinator.finalize()
    intervention.finalize()

    campaign = {}
    campaign["Events"] = []
    campaign["Events"].append( event )
    new_event_filename = "import_pressure.json"
    with open( new_event_filename, "w" ) as camp_file:
        json.dump( campaign, camp_file, sort_keys=True, indent=4 )
    return new_event_filename 

